Attribute VB_Name = "1"
Option Explicit

Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Const HTCAPTION = 2

'////////////////////////////////////////////////////
Private Const WM_NCCREATE = &H81
Private Const WM_NCDESTROY = &H82
Private Const WM_NCCALCSIZE = &H83
Private Const WM_NCHITTEST = &H84
Private Const WM_NCPAINT = &H85
Private Const WM_NCACTIVATE = &H86
Private Const WM_GETDLGCODE = &H87
Private Const WM_SYNCPAINT = &H88
Private Const WM_NCMOUSEMOVE = &HA0
Public Const WM_NCLBUTTONDOWN = &HA1
Private Const WM_NCLBUTTONUP = &HA2
Private Const WM_NCLBUTTONDBLCLK = &HA3
Private Const WM_NCRBUTTONDOWN = &HA4
Private Const WM_NCRBUTTONUP = &HA5
Private Const WM_NCRBUTTONDBLCLK = &HA6
Private Const WM_NCMBUTTONDOWN = &HA7
Private Const WM_NCMBUTTONUP = &HA8
Private Const WM_NCMBUTTONDBLCLK = &HA9
' * GetDCEx() flags
Private Const DCX_WINDOW = &H1
Private Const DCX_CACHE = &H2
Private Const DCX_NORESETATTRS = &H4
Private Const DCX_CLIPCHILDREN = &H8
Private Const DCX_CLIPSIBLINGS = &H10
Private Const DCX_PARENTCLIP = &H20
Private Const DCX_EXCLUDERGN = &H40
Private Const DCX_INTERSECTRGN = &H80
Private Const DCX_EXCLUDEUPDATE = &H100
Private Const DCX_INTERSECTUPDATE = &H200
Private Const DCX_LOCKWINDOWUPDATE = &H400
Private Const DCX_VALIDATE = &H200000

'////////////////////////////////////////////////////////////////////////////////////////////////////
Declare Sub ReleaseCapture Lib "user32" ()
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal Y As Long) As Long
Declare Function WindowFromDC Lib "user32" (ByVal hDC As Long) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Integer
Declare Function FrameRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
'////////////////////////////////////////////////////////////////////////////////////////////////////
Private Declare Function GetDCEx Lib "USER32.DLL" (ByVal hwnd As Long, ByVal hRgnClip As Long, ByVal fdwOptions As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetClipboardViewer Lib "user32" (ByVal hwnd As Long) As Long
Private Const WM_DRAWCLIPBOARD = &H308
Private Const GWL_WNDPROC = (-4)
Private PrevProc As Long

Public Sub HookForm(F As Form)
    PrevProc = SetWindowLong(F.hwnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub
Public Sub UnHookForm(F As Form)
    SetWindowLong F.hwnd, GWL_WNDPROC, PrevProc
End Sub
Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    WindowProc = CallWindowProc(PrevProc, hwnd, uMsg, wParam, lParam)

     If uMsg = WM_NCPAINT Then
        Dim hDC As Long
        hDC = GetDCEx(hwnd, wParam, DCX_WINDOW Or DCX_INTERSECTRGN)
        Call Form1.Paint_Proc(hwnd, hDC)
    End If
    
End Function
